"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.proxyAxiosMethods = exports.addInstanceExtendMethod = exports.normalizeConfig = void 0;
var tslib_1 = require("tslib");
var qs_1 = tslib_1.__importDefault(require("qs"));
/**
 * 标准化config配置，或根据配置项设置相关的参数
 * 该函数返回的配置对象，应该完全符合axios的配置规范
 * @param {*} config
 */
function normalizeConfig(ctx, config) {
    var _a = tslib_1.__assign(tslib_1.__assign({}, ctx.$options), config), _b = _a.headers, headers = _b === void 0 ? {} : _b, _c = _a.sendFormData, sendFormData = _c === void 0 ? false : _c, _d = _a.data, data = _d === void 0 ? undefined : _d, _e = _a.params, params = _e === void 0 ? {} : _e, _f = _a.baseUrl, baseUrl = _f === void 0 ? '' : _f, _g = _a.baseURL, baseURL = _g === void 0 ? '' : _g, rest = tslib_1.__rest(_a, ["headers", "sendFormData", "data", "params", "baseUrl", "baseURL"]);
    // 数据格式为FormData，修改content-type头，以及修改data格式
    var contentType = headers['content-type'] || headers['Content-Type'] || 'application/json';
    headers['content-type'] = sendFormData ? 'application/x-www-form-urlencoded' : contentType;
    var sendData = sendFormData && typeof data === 'object' && data !== null ? qs_1.default.stringify(data) : data;
    // baseUrl，支持两种写法，且用户配置的baseUrl优先级最高
    var bUrl = baseUrl || baseURL || ctx.$baseUrl;
    return tslib_1.__assign({ headers: headers, params: params, data: sendData, baseURL: bUrl }, rest);
}
exports.normalizeConfig = normalizeConfig;
function addInstanceExtendMethod(ctx) {
    var extend = function (source) {
        Object.keys(source).forEach(function (key) {
            ctx[key] = source[key];
        });
    };
    ctx.extend = extend;
}
exports.addInstanceExtendMethod = addInstanceExtendMethod;
function proxyAxiosMethods(target, source) {
    var methods = ['request', 'interceptors'];
    // const methods: ProxyedAttrs[] = ['request', 'get', 'post', 'delete', 'head', 'options', 'put', 'patch', 'interceptors'];
    methods.forEach(function (method) {
        Object.defineProperty(target, method, {
            value: source[method],
            writable: false,
        });
    });
}
exports.proxyAxiosMethods = proxyAxiosMethods;
//# sourceMappingURL=helpers.js.map