export { generateRequestHash  } from "./utils"

const pendingRequest: Record<string, any> = {}

export function addPendingRequest(hash: string, request: Promise<any>, timeout = 300) {
  let timer
  pendingRequest[hash] = request
  timer = setTimeout(() => {
    clearPendingRequest(hash)
  }, timeout)
}

export function clearPendingRequest(hash: string) {
  Reflect.deleteProperty(pendingRequest, hash)
}

export function checkIfHasPendingRequest(hashKey: string): boolean {
  return Reflect.has(pendingRequest, hashKey)
}

export function getCachedRequest(hashKey: string) {
  return pendingRequest[hashKey]
}